from adoconstants import *
from string import join, split, find, strip, translate, maketrans
import sys, types
from Shared.DC.ZRDB.THUNK import THUNKED_TM
from win32com.client import Dispatch
import pythoncom
rc=sys.getrefcount

error=DatabaseError='ADO Database Error'

defs={
  adSmallInt: 'i',
  adInteger: 'i',
  adSingle: 'n',
  adDouble: 'n',
  adCurrency: 'n',
  adDate: 'd',
  adBSTR: 't',
  adBoolean: 'i',
  adDecimal: 'n',
  adTinyInt: 'i',
  adUnsignedTinyInt: 'i',
  adUnsignedSmallInt: 'i',
  adUnsignedInt: 'i',
  adBigInt: 'i',
  adUnsignedBigInt: 'i',
  adBinary: 't',
  adChar: 't',
  adWChar: 't',
  adNumeric: 'n',
  adDBDate: 'd',
  adDBTime: 'd',
  adDBTimeStamp: 'd',
  adVarNumeric: 'n',
  adVarChar: 't',
  adLongVarChar: 't',
  adVarWChar: 't',
  adLongVarWChar: 't',
  adVarBinary: 't',
  adLongVarBinary: 't',
  }

binary_types=adBinary, adLongVarBinary, adVarBinary

class DB(THUNKED_TM):
  """This class connects actually to the database and performs the query execution"""
  
  def __init__(self, connection_string=''):
    """Initializes the database connection"""
    self.connection_string=connection_string
    self.isConnected = 0
##        d=split(connection_string)
##        if len(d) < 1 or len(d) > 3:
##            raise 'Invalid Connection String', d
##        while len(d) < 3: d.append('')
##        self.connection=c=SQLConnection(d[0],d[1],d[2])
##        try: SQLSetConnectOption(c,SQL_AUTOCOMMIT,SQL_AUTOCOMMIT_OFF)
##        except: pass # Oh well
##        self.stmt=c()

  def connect(self):
    """Connects the database connection to the database"""
    if not self.isConnected:
      pythoncom.CoInitialize()
      # ADO-Verbindung erzeugen
      oConn = Dispatch('ADODB.Connection')
      oConn.ConnectionString = self.connection_string
      oConn.Open()
      self.connection = oConn
      self.isConnected = 1
      return 0 # was not connected
    return 1 # was connected

  def disconnect(self):
    """Disconnects the database connection from the database"""
    if self.isConnected:
      self.connection.Close()
      self.connection = None
      pythoncom.CoUninitialize()
      self.isConnected = 0
    
  def table_info(self):
    """Returns info about the tables contained in a database"""
    wasConnected = self.connect()
    oCat = Dispatch('ADOX.Catalog')
    oCat.ActiveConnection = self.connection
    oTab = oCat.Tables
    r=[]
    for table in oTab:
      if table.Type == 'TABLE':
	name = table.Name
	try:
	  owner = '(owned by %s)'%oCat.GetObjectOwner(name, adCmdTable)
	except:
	  owner = ''
##      q, owner, name, type, remarks = tuple(split(row,'\t'))
##      if owner: owner="(owned by %s) " % owner
##      owner=owner+remarks
##      if owner: owner=', '+owner
	r.append((name, owner))
    # ActiveX Catalog schliessen und freigeben
    oCat = None

    # wenn noch keine Datenbank-Verbindung bestanden hat, dann wieder schliessen
    if not wasConnected:
      self.disconnect()
      
    return r

##  def tables(self, Qualifier=None, Owner=None, Name=None, Type=None, rdb=1):
##    """Returns the names of all tables in a database"""
##    SQLTables(self.stmt, Qualifier, Owner, Name, Type)
##    return self.query(rdb=rdb)

  def query(self, src=None, max_rows=99999999, rdb=1):
    """Executes a query and returns the result"""
    self._register()
    wasConnected = self.connect()

    try:
      if src is not None:
	r=filter(strip,split(src,'\0'))
	if not r: raise ValueError, 'null sql'
	if len(r) > 1:
	  res=None
	  try:
	    for s in r:
	      # Excecute query
	      (oRS, result) = self.connection.Execute(s)
	      if ncol:
		if res is not None:
		  raise ValueError, (
		      'multiple selects are not allowed')
		res = self.prepareResultSet(oRS, rdb)
		# close ResultSet object and release it
		oRS.Close()
		oRS = None
	    if res==None:
	      if rdb: res="x\n8s\n"
	      else: res=()
	  finally:
	    # if not database connection has existed before, then close it
	    if not wasConnected:
	      self.disconnect()

	  return res

	try:
	  (oRS, result) = self.connection.Execute(src)
	except error, v:
	  # if not database connection has existed before, then close it
	  if not wasConnected:
	    self.disconnect()
	  raise error, v


    except error, v:
      state, native, mess = v
      raise error, "%s (%s)" % (mess, state)

    try:
      r = self.prepareResultSet(oRS, rdb=rdb)
    finally:
      # close ResultSet object and release it
      oRS.Close()
      oRS = None
      # wenn noch keine Datenbank-Verbindung bestanden hat, dann wieder schliessen
      if not wasConnected:
	self.disconnect()

    if rdb:
      r = join(r,u'\n'.encode('iso8859-1'))
      r += u'\n'.encode('iso8859-1')

    return r

  def prepareResultSet(self, oRS, rdb):
    """Takes an ADO ResultSet Object and prepares it for Zope"""
    
    ncol = oRS.Fields.Count
    r=[]
    row=[u''.encode('iso8859-1')]*ncol
    names=[u''.encode('iso8859-1')]*ncol
    rdbdefs=[u''.encode('iso8859-1')]*ncol
    indexes=range(ncol)
    binary_flags=[0]*ncol
    for i in range(ncol):
      name = oRS.Fields.Item(i).Name.encode('iso8859-1')
      type = oRS.Fields.Item(i).Type
      prec = oRS.Fields.Item(i).Precision
      scale = oRS.Fields.Item(i).NumericScale
      nullable = ((oRS.Fields.Item(i).Attributes & adFldIsNullable) == adFldIsNullable
		  or (oRS.Fields.Item(i).Attributes & adFldMayBeNull) == adFldMayBeNull)
      names[i]=name
      if prec < 1: prec=8
      binary_flags[i]=type in binary_types
      if defs.has_key(type): type=defs[type].encode('iso8859-1')
      else: type=u't'.encode('iso8859-1')
      if type==u'n' and scale==0: type=u'i'.encode('iso8859-1')
      rdbdefs[i]=type
      row[i]="%s%s" % (prec,type)

    if rdb:
      r.append(join(names,u'\t'.encode('iso8859-1')))
      r.append(join(row,u'\t'.encode('iso8859-1')))

    while not oRS.EOF:
      for i in range(ncol):
	v=oRS.Fields.Item(i).Value
	if rdbdefs[i]=='t' and v != None:
	  v = str(v.encode('iso8859-1'))
	  if find(v,u'\\'.encode('iso8859-1')) >= 0: v=join(split(v,u'\\'.encode('iso8859-1')),u'\\\\'.encode('iso8859-1'))
	  if find(v,u'\n'.encode('iso8859-1')) >= 0: v=join(split(v,u'\n'.encode('iso8859-1')),u'\\n'.encode('iso8859-1'))
	  if find(v,u'\t'.encode('iso8859-1')) >= 0: v=join(split(v,u'\t'.encode('iso8859-1')),u'\\t'.encode('iso8859-1'))
	elif rdbdefs[i] == 'd' and v != None:
	  v = v.Format('%Y/%m/%d %H:%M:%S').encode('iso8859-1')
	elif v == None:
	  v = ''.encode('iso8859-1')
	else:
	  if rdbdefs[i] == 'n':
	    v = cvtFloat(v)
	  v = str(v)
	row[i]=v
      if rdb: rd=join(row,u'\t'.encode('iso8859-1'))
      else:
	rd={}
	for i in indexes: rd[names[i]]=row[i]
      r.append(rd)
      oRS.MoveNext()

    return r

##  def columns(self, table_name):
##    """Returns all column names of a table"""
##    stmt=self.stmt
##    try: SQLExecDirect(stmt, 'select * from %s where 1=2' % table_name)
##    except error, v:
##      state, native, mess = v
##      raise error, "%s (%s)" % (mess, state)

##    status, ncol = SQLNumResultCols(stmt)
##    r=[]
##    standard_type=tpnames.has_key
##    for i in range(ncol):
##      status, name, tp, prec, scale, nullable=SQLDescribeCol(stmt,i+1)
##      if standard_type(tp): tp=tpnames[tp]
##      else: tp="Non-standard type %s" % tp
##      r.append({'Name': name, 'Type': tp, 'Precision': prec,
##		'Scale': scale,
##		'Nullable': nullable and 'with Null' or ''})

##    SQLFreeStmt(stmt, SQL_CLOSE);
##    return r

  def _begin(self):
    """Begins a transaction"""
    pass

  def _finish(self):
    """Commits a transaction"""
    pass
##    SQLTransact(self.connection, SQL_COMMIT)
    
  def _abort(self):
    """Aborts a transaction"""
    pass
##    SQLTransact(self.connection, SQL_ROLLBACK)


def cvtFloat(variant):
  try:
    return float(variant)
  except (ValueError,TypeError):
    pass
  if type(variant)==types.TupleType:
    return cvtMoney(variant)
  try:
    europeVsUS=translate(str(variant),maketrans(".,",",."))
    return float(europeVsUS)
  except (ValueError,TypeError):
    pass    
  
if __name__=='__main__':
  #print manage_ODBCDataSources()
  db=DB('test')
  #print db.table_info()
  if len(sys.argv)==2: print db.query(sys.argv[1])
  else: print db.tables(rdb=0)
  #print db.columns('f')
